/* Bibliothque X-Window pour les interfaces
            Dclaration des fonctions gnrales
	    Compatible avec gem_gene.c (version GEM : rfrence)
   (C) 1998, Emmanuel CURIS

 25 mars 1998
   * Cration du fichier
   * Dclaration de initialise()
*/

#ifndef X_GENERAL_H_

#define X_GENERAL_H_ /* Protection contre l'inclusion multiple */

/* ~~~~~~~~~~ Boucle d'vnements ~~~~~~~~~~~~~~~~~~~ */

struct fenetre;

#ifdef _LIBRAIRIE_X_ /* Fonctions internes  la librairie X... */
int EVNT_relache       (XKeyEvent *clavier);
int EVNT_entree        (Fenetre *fenetre, XCrossingEvent *evenement);
int EVNT_sortie        (Fenetre *fenetre, XCrossingEvent *evenement);
int EVNT_pointeur      (Fenetre *fenetre, XMotionEvent *pointeur);
int EVNT_redessin      (Fenetre *fenetre, XExposeEvent *redessin);
int EVNT_relache_bouton(Fenetre *fenetre, XButtonEvent *souris);
int EVNT_Activation    (Fenetre *fenetre, XFocusChangeEvent *souris);
int EVNT_TraiterClic   (Fenetre *fenetre, XButtonEvent *souris, int n_clics);

boolean EVNT_MemoriserClic (Fenetre *fenetre, XButtonEvent *souris, XEvent *ancien, int *n_clics);
#endif /* _LIBRAIRIE_X_ */

/* ~~~~~~~~~~ Clavier ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

#define K_RSHIFT    0x0001
#define K_LSHIFT    0x0002
#define K_CTRL      0x0004
#define K_ALT       0x0008

/* ~~~~~~~~~~ Souris ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

#define ARROW            0
#define S_FLECHE         0
#define TEXT_CRSR        1
#define HOURGLASS        2
#define BUSY_BEE         2 /* for compatibility */
#define S_ABEILLE        2
#define POINT_HAND       3
#define FLAT_HAND        4
#define THIN_CROSS       5
#define THICK_CROSS      6
#define OUTLN_CROSS      7
#define M_PUSH         100
#define M_POP          101
#define USER_DEF       255
#define M_OFF          256
#define M_ON           257

typedef struct grect
{
  int g_x;
  int g_y;
  int g_w;
  int g_h;
} GRECT;

boolean Rc_intersect(int x_1, int y_1, unsigned int larg_1, unsigned int haut_1,
		     int *x, int *y, unsigned int *larg, unsigned int *haut);

#endif /* X_GENERAL_H_ */
