/* Bibliothque X-Window pour les interfaces
            Dclaration des variables globales (fichier  inclure)
	    Compatible avec gem_gene.c (version GEM : rfrence)
   (C) 1998, Emmanuel CURIS

   Cration : 25 mars 1998
*/

#ifndef X_VARIABLES_H_

#define X_VARIABLES_H_ 

#include "X_vdi.h"

/* ------------- Spcifiques  X-Windows --------------- */

/* -------- Visibles de l'extrieur :
            permet le paramtrage externe de la librairie X -------- */

extern boolean  BI_2_egale_3;       /* Confusion des boutons 2 et 3 si VRAI */
extern boolean  BI_synchronisation; /* X synchrone */
extern char    *BI_nom_fonte;       /* Nom de la fonte  utiliser */

extern unsigned int BI_larg_ecran , BI_haut_ecran ; /* Dimensions utilisables de l'cran, en pixels */
extern unsigned int BI_larg_defaut, BI_haut_defaut; /* Dimensions des fentres par dfaut,
						       exprimes en pixels */

extern boolean BI_OpenGL_actif;    /* Est-ce qu'Open-GL est prsent ? */
extern boolean BI_GL_direct; /* VRAI : dessin direct  l'cran, FAUX : passe par un Pixmap */

extern boolean BI_Freedesktop_OK; /* VRAI : protocole avanc pour les bureaux */

#ifdef _LIBRAIRIE_X_ /* Usage uniquement pour la librairie X */

/* -------- Invisibles de l'extrieur :
            usage limit  la librairie d'interface X -------- */

extern int buffer[];

extern Atom BI_ProtocoleFermerFenetre;
extern Atom _NET_ACTIVE_WINDOW;

extern Colormap  BI_Palette; /* La palette de couleurs ? */
extern Display  *BI_Display; /* Paramtres d'affichage   */
extern GC        BI_GC_programme; /* Environnement graphique gnral */
extern GC        BI_GC_objets;    /* Environnement graphique pour le dessin des ressources */

extern Visual   *BI_Visual;      /*  quoi a peut bien servir ? */
extern Screen   *BI_Ecran;
extern int       BI_Num_ecran;

extern XIM       BI_Methode_entree;  /* La mthode d'entre au clavier [gestion UTF-8 en particulier] */
extern XIMStyle  BI_Methode_choisie; /* Parmi les mthodes possibles, celle choisie */

extern Window    BI_Fen_racine;
extern Window    BI_Fen_redessin;

extern XColor       BI_Couleur;	   /* Couleur dfinie pour X-Window */
extern XColor       BI_Couleurs[]; /* Couleurs de base GEM */
extern XFontStruct *BI_Fonte;      /* Fonte utilise pour les affichages de texte par dfaut */
extern XFontSet     BI_FonteUTF8;  /* Fonte utilise pour les affichages en UTF-8 */

extern const char *BI_fonte_defaut;
extern unsigned int BI_larg_car, BI_haut_car;

extern XSetWindowAttributes BI_Attributs; /* Attributs de fentre */

extern unsigned int BI_nbr_arbres;     /* Nombre d'arbres dans le programme */
#define BI_ArbreAlerte    (BI_nbr_arbres - 3)
#define BI_ArbreSelecteur (BI_nbr_arbres - 2)
#define BI_ArbreSousMenu  (BI_nbr_arbres - 1)

extern int BI_PRG_menu;       /* Numro de l'arbre servant de menu */
extern int BI_PRG_arbre;      /* Arbre actif (dans ext_formdo)     */

extern Arbre *BI_ARB_fselect; /* Arbre contenant le slecteur de fichiers */

extern OBJECT Boite_d_alerte[];

extern Menu *BI_Menu;

extern boolean BI_Serveur_X_bloque;

extern int BI_x_souris, BI_y_souris;
extern int BI_bouton;

extern int BI_double_clic; /* Attente pour le double clic */

#endif /* _LIBRAIRIE_X_ */

/* -------------- Gnrales du programme (gem_var.h) --- */

extern Station_VDI *_PRG_station;

extern long gdos;                         /* Version de GDOS installe */

extern int BI_etat;

extern Arbre *arbres;       /* Adresses des structures d'arbres  */

extern Fenetre *BI_premiere_fenetre;

#ifdef AVEC_OPEN_GL_ /* Ces variables n'ont de sens qu'avec Open GL */
extern XVisualInfo XGL_Visual;
extern Colormap    XGL_Palette;

extern boolean     BI_OpenGL_dBuffer;
#endif

#endif /* X_VARIABLES_H_ */
