/* Utilisation des nombres complexes
   (C) 2002, Emmanuel Curis (repris de Lase)
*/

#ifndef UTILS_COMPLEXES_H_
# define  UTILS_COMPLEXES_H_ /* Protection, inclusion multiple */

typedef struct
{
  double re;
  double im;
} Complexe; /* Nombre complexe */

double CMPL_argument(Complexe z);
double CMPL_module  (Complexe z);

/* ------ Oprations de base -------- */

Complexe CMPL_somme     (Complexe a, Complexe b);
Complexe CMPL_produit   (Complexe a, Complexe b);
Complexe CMPL_quotient  (Complexe a, Complexe b);
Complexe CMPL_difference(Complexe a, Complexe b);

#endif /* UTILS_COMPLEXES_H_ */
