/* Bibliothque GEM pour X-Windows
   (C) 1998, Emmanuel CURIS

   Dclarations des fonctions
   Bibliothque d'vnements (EVNT lib)

*/

#ifndef X_EVNT_LIB_H_

#define X_EVNT_LIB_H_ /* Protection contre l'inclusion multiple */

/* ~~~~~~~~~~ Les messages GEM prdfinis ~~~~~~~~~~ */

#define MN_SELECTED     10 /* On a appel une option de menu */
#define WM_REDRAW       20 /* Message de redessin */
#define WM_TOPPED       21 /* Passage au premier plan */
#define WM_CLOSED       22 /* Fermeture */
#define WM_FULLED       23 /* Plein cran */
#define WM_ARROWED      24 /* Clic sur une flche */
#define WM_HSLID        25 /* Ascenseur horizontal */
#define WM_VSLID        26 /* Ascenseur vertical */
#define WM_SIZED        27 /* Changement de taille */
#define WM_MOVED        28 /* Dplacement de la fentre */
#define WM_NEWTOP       29 /* for compatibility  - non document */
#define WM_UNTOPPED     30 /* Non document */
#define WM_ONTOP        31 /* Quand fentre passe au premier plan */
#define WM_OFFTOP       32 /* Quand fentre disparat du premier plan */
#define WM_BOTTOM       33 /* Passage en arrire plan */
#define WM_ICONIFY      34 /* On demande de l'iconifier */
#define WM_UNICONIFY    35 /* On demande de la dsiconifier */
#define WM_ALLICONIFY   36 /* On demande de tout iconifier */
#define WM_TOOLBAR      37 /* Message d'un arbre en barre d'info */

#define PR_FINISH       33 /*  quoi diable correspond-il ??? */

#define AC_OPEN         40
#define AC_CLOSE        41

#define AP_TERM         50
#define AP_TFAIL        51
#define AP_RESCHG       57
#define SHUT_COMPLETED  60
#define RESCH_COMPLETED 61
#define AP_DRAGDROP     63

#define CH_EXIT         80

/* ~~~~~~~~~~ Sous-commandes des messages de fentre ~~~~~~~~ */

#define WA_SUBWIN        1
#define WA_KEEPWIN       2

#define WA_UPPAGE        0 /* Window Arrow Up Page    */
#define WA_DNPAGE        1 /* Window Arrow Down Page  */
#define WA_UPLINE        2 /* Window Arrow Up Line    */
#define WA_DNLINE        3 /* Window Arrow Down Line  */
#define WA_LFPAGE        4 /* Window Arrow Left Page  */
#define WA_RTPAGE        5 /* Window Arrow Right Page */
#define WA_LFLINE        6 /* Window Arrow Left Line  */
#define WA_RTLINE        7 /* Window Arrow Right Line */

#endif /* X_EVNT_LIB_H_ */
