/* Routines utilitaires pour LASE et autres
   (C) 2002, Emmanuel CURIS

   Gestion d'un historique : sauvegarde dans un fichier du dtail des oprations
*/

#ifndef UTILS_HISTORIQUE_H_
# define UTILS_HISTORIQUE_H_ /* Protection */

#ifndef VRAI
# define FAUX 0
# define VRAI 1
#endif

int  HIST_LancerHistorique (const char *nom, unsigned int niveau);
void HIST_ArreterHistorique(void);
int  HIST_ChangerNiveau    (unsigned int nv_niveau);

void HIST_Erreur(unsigned int niveau, const char *action, const char *raison);
void HIST_Titre (int niveau, const char *titre, const char *code);
void HIST_Texte (unsigned int niveau, int decalage, const char *masque, ...);

void HIST_Polynome(unsigned int niveau_formule, unsigned int niveau_coefficients, int decalage,
		   double *table, unsigned long nbr_valeurs, int premier_code);
void HIST_Table   (unsigned int niveau, int decalage, double *table, unsigned long nbr_valeurs, int premier_code);

#endif /* UTILS_HISTORIQUE_H_ */
